"use strict";
var core_1 = require('./core');
var util_1 = require('./util');
var WATCH_PROP = '$$Watch';
function Watch(func, option) {
    return function (target, key) {
        var watchedProps = target[WATCH_PROP] = target[WATCH_PROP] || util_1.createMap();
        if (!option) {
            watchedProps[key] = func;
            return;
        }
        option.handler = func;
        watchedProps[key] = option;
    };
}
exports.Watch = Watch;
core_1.Component.register(WATCH_PROP, function (target, instance, optionsToWrite) {
    var watchedProps = target[WATCH_PROP];
    var watch = optionsToWrite.watch;
    for (var key in watchedProps) {
        watch[key] = watchedProps[key];
    }
});
